''
'' VGA driver 320x256 (single cog) - demo
''
''        Author: Marko Lukat
'' Last modified: 2013/04/21
''       Version: 0.3
''
CON
  _clkmode = XTAL1|PLL16X
  _xinfreq = 5_000_000
  
CON
  res_x = driver#res_x
  res_y = driver#res_y

  quadP = res_x * res_y / 32
  quadC = res_x * res_y / 256
  
OBJ
  driver: "waitvid.320x256.driver.2048"
    font: "generic8x8-1font"

VAR
  long  link[driver#res_m], base

  long  screen[quadP]
  long  colour[quadC]
  
PUB selftest

  link{0} := @screen{0}
  link[1] := @colour{0}
  driver.init(-1, @link{0})                             ' start driver

  base := font.addr
  frqa := frqb := cnt
  
  fill

  link[2] := @pb{0}                                     ' |
  repeat while link[2]                                  ' update palette
  
  repeat                                                  
    fill
  
PRI print(x, y, c, col) : b

  b := x + y * 320
  c &= 255
  
  repeat 8
    screen.byte[b] := byte[base][c]
    b += 40
    c += 256

  colour.byte[x + y * 40] := col{& $7F}
  
PRI fill : n | x, y

  repeat y from 0 to 31         
    repeat x from 0 to 39       
      print(x, y, n++, ?frqb)   
      waitcnt(clkfreq/120 + cnt)
                                
  repeat n from 0 to 2559       
    screen[n] := ?frqa          
    waitcnt(clkfreq/240 + cnt)  

DAT

' Foreground colour is in byte 1, background in 3 and 0.

pb{ackground}   long    $0000 -> 8, $0C0C -> 8, $3030 -> 8, $3C3C -> 8
                long    $C0C0 -> 8, $CCCC -> 8, $F0F0 -> 8, $FCFC -> 8

pf{oreground}   long    $0000, $0800, $1000, $1800, $2000, $2800, $3000, $3800
                long    $8000, $8800, $9000, $9800, $A000, $A800, $B000, $B800

DAT